<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>Task 51.20</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Home</a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Pet</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8;"
          />
          <span class="brand-text font-weight-light">DEVCAMP</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar User (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Le Nguyen</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Dashboard
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                <ul class="nav nav-treeview">
                  <li class="nav-item">
                    <a href="#" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Home</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Pet</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>Quản trị Pet</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">Pet</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content">
          <!-- Default box -->
          <div class="card">
            <!-- Vùng header -->
            <div class="container">
              <div
                class="form-group mt-3"
                style="display: flex; justify-content: space-between;"
              >
                <button class="btn btn-success" id="btn-add-pet">
                  <i class="fa fa-plus"></i>&nbsp; New Pet
                </button>
                <div style="display: flex; align-items: center;">
                  <label>Price từ</label>
                  <input
                    class="form-control mx-2"
                    style="width: 5rem;"
                    type="number"
                    id="input-min-price"
                  />
                  <label>đến</label>
                  <input
                    class="form-control mx-2"
                    style="width: 5rem;"
                    type="number"
                    id="input-max-price"
                  />
                  <button class="btn btn-success" id="btn-loc">Lọc</button>
                </div>
              </div>
            </div>
            <!-- Pet Data Table -->
            <div class="container">
              <table
                class="table table-bordered table-striped table-hover"
                id="pet-table"
              >
                <thead>
                  <tr>
                    <th>STT</th>
                    <th>Name</th>
                    <th>Type</th>
                    <th>Description</th>
                    <th>Image</th>
                    <th>Price</th>
                    <th>Promotion<br />Price</th>
                    <th>Discount</th>
                    <th>Action</th>
                  </tr>
                </thead>
              </table>
            </div>
            <!-- Vùng Modal -->

            <!-- Create Pet modal -->
            <div>
              <div id="create-pet-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">
                        Create new pet
                      </h5>
                      <button class="close" data-dismiss="modal">
                        &times;
                      </button>
                    </div>
                    <div class="modal-body">
                      <form>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Type</label>
                          </div>
                          <div class="col-sm-8">
                            <select
                              id="select-create-type"
                              class="form-control"
                            >
                              <option value="Dog">Dog</option>
                              <option value="Cat">Cat</option>
                              <option value="Fish">Fish</option>
                              <option value="Bird">Bird</option>
                              <option value="Rabbit">Rabbit</option>
                            </select>
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Name</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-name"
                              placeholder="Pet name"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Description</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-description"
                              placeholder="Pet description"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Image</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-image"
                              placeholder="Pet image"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Price</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-price"
                              placeholder="Pet price"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Promotion Price</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-promotion-price"
                              placeholder="Promotion Price"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Discount</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-discount"
                              placeholder="Discount"
                              class="form-control"
                            />
                          </div>
                        </div>
                      </form>
                    </div>
                    <div class="modal-footer">
                      <button
                        class="btn btn-secondary"
                        id="btn-create-cancel"
                        data-dismiss="modal"
                      >
                        Cancel
                      </button>
                      <button class="btn btn-primary" id="btn-create-pet">
                        Create Pet
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- Update Pet modal -->
            <div>
              <div id="update-pet-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">
                        Update a pet
                      </h5>
                      <button class="close" data-dismiss="modal">
                        &times;
                      </button>
                    </div>
                    <div class="modal-body">
                      <form>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Type</label>
                          </div>
                          <div class="col-sm-8">
                            <select
                              id="select-update-type"
                              class="form-control"
                            >
                              <option value="Dog">Dog</option>
                              <option value="Cat">Cat</option>
                              <option value="Fish">Fish</option>
                              <option value="Bird">Bird</option>
                              <option value="Rabbit">Rabbit</option>
                            </select>
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Name</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-name"
                              placeholder="Pet name"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Description</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-description"
                              placeholder="Pet description"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Image</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-image"
                              placeholder="Pet image"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Price</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-price"
                              placeholder="Pet price"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Promotion Price</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-promotion-price"
                              placeholder="Promotion Price"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Discount</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-discount"
                              placeholder="Discount"
                              class="form-control"
                            />
                          </div>
                        </div>
                      </form>
                    </div>
                    <div class="modal-footer">
                      <button
                        class="btn btn-secondary"
                        id="btn-update-cancel"
                        data-dismiss="modal"
                      >
                        Cancel
                      </button>
                      <button class="btn btn-primary" id="btn-update-pet">
                        Update Pet
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- Delete confirm modal -->
            <div>
              <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">
                        Pet Delete Confirmation
                      </h5>
                      <button class="close" data-dismiss="modal">
                        &times;
                      </button>
                    </div>
                    <div class="modal-body">
                      <label>Bạn có chắc chắn muốn xóa pet này không?</label>
                    </div>
                    <div class="modal-footer">
                      <button
                        class="btn btn-danger"
                        id="btn-confirm-delete-pet"
                      >
                        Confirm
                      </button>
                      <button class="btn btn-secondary" data-dismiss="modal">
                        Cancel
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- /.card -->
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 1.0.0</div>
        <strong>Copyright &copy; 2023 <a href="#">Devcamp</a>.</strong> All
        rights reserved.
      </footer>
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- Data Table-->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </body>
</html>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Biến toàn cục để lưu trữ id Pet đang đc update or delete. Mặc định = 0;
  var gPetId = 0;

  const gBASE_URL = "https://pucci-mart.onrender.com/api";

  // Biến mảng hằng số chứa danh sách tên các thuộc tính
  const gPET_COLS = [
    "stt",
    "name",
    "type",
    "description",
    "imageUrl",
    "price",
    "promotionPrice",
    "discount",
    "action",
  ];

  // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
  const gSTT_COL = 0;
  const gNAME_COL = 1;
  const gTYPE_COL = 2;
  const gDES_COL = 3;
  const gIMG_COL = 4;
  const gPRICE_COL = 5;
  const gPRO_PRICE_COL = 6;
  const gDISCOUNT_COL = 7;
  const gACTION_COL = 8;

  // Biến toàn cục để hiển lưu STT
  var gSTT = 1;
  // Khai báo DataTable & mapping collumns
  var gPetTable = $("#pet-table").DataTable({
    searching: false,
    ordering: false,
    columns: [
      { data: gPET_COLS[gSTT_COL] },
      { data: gPET_COLS[gNAME_COL] },
      { data: gPET_COLS[gTYPE_COL] },
      { data: gPET_COLS[gDES_COL] },
      { data: gPET_COLS[gIMG_COL] },
      { data: gPET_COLS[gPRICE_COL] },
      { data: gPET_COLS[gPRO_PRICE_COL] },
      { data: gPET_COLS[gDISCOUNT_COL] },
      { data: gPET_COLS[gACTION_COL] },
    ],
    columnDefs: [
      {
        // định nghĩa lại cột STT
        targets: gSTT_COL,
        render: function () {
          return gSTT++;
        },
      },
      {
        targets: gIMG_COL,
        render: function (data) {
          return `
            <img src="${data}" class="img-thumbnail" style="width: 7rem; height: 5rem;"/>
          `;
        },
      },
      {
        // định nghĩa lại cột action
        targets: gACTION_COL,
        defaultContent: `
          <img class="edit-pet" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
          <img class="delete-pet" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
        `,
      },
    ],
  });

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    // thực hiện tải trang
    onPageLoading();
    // 2 - C: gán sự kiện Create - Thêm mới Pet
    $("#btn-add-pet").on("click", function () {
      onBtnAddNewPetClick();
    });
    // 3 - U: gán sự kiện Update - Sửa 1 Pet
    $("#pet-table").on("click", ".edit-pet", function () {
      onBtnEditPetClick(this);
    });
    // 4 - D: gán sự kiện Delete - Xóa 1 Pet
    $("#pet-table").on("click", ".delete-pet", function () {
      onBtnDeletePetClick(this);
    });

    // gán sự kiện cho nút Create Pet (trên modal)
    $("#btn-create-pet").on("click", function () {
      onBtnCreatePetClick();
    });

    // gán sự kiện cho nút Update Pet (trên modal)
    $("#btn-update-pet").on("click", function () {
      onBtnUpdatePetClick();
    });

    //gán sự kiện cho nút Lọc khi nhấn
    $("#btn-loc").on("click", function () {
      onBtnLocClick();
    });
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm thực thi khi trang được load
  function onPageLoading() {
    // 1 - R: Read / Load Pet to DataTable
    getAllPets();
  }

  // Hàm xử lý sự kiện khi nút Thêm mới đc click
  function onBtnAddNewPetClick() {
    // hiển thị modal trắng lên
    $("#create-pet-modal").modal("show");
  }

  // Hàm xử lý sự kiện khi icon edit Pet trên bảng đc click
  function onBtnEditPetClick(paramBtnEdit) {
    // lưu thông tin PetId đang được edit vào biến toàn cục
    gPetId = getPetIdFromButton(paramBtnEdit);
    // load dữ liệu vào các trường dữ liệu trong modal
    getPetById(gPetId);
  }

  // hàm xử lý sự kiện create Pet modal click
  function onBtnCreatePetClick() {
    // khai báo đối tượng chứa Pet data
    var vPetObj = {
      type: "",
      name: "",
      description: "",
      imageUrl: "",
      price: 0,
      promotionPrice: 0,
      discount: 0,
    };
    // B1: Thu thập dữ liệu
    getCreatePetData(vPetObj);
    // B2: Validate insert
    var vIsPetValidate = validatePetData(vPetObj);
    if (vIsPetValidate) {
      // B3: insert Pet
      $.ajax({
        type: "post",
        headers: {
          "Content-Type": "application/json",
        },
        url: gBASE_URL + "/pets",
        dataType: "json",
        data: JSON.stringify(vPetObj),
        success: function (paramData) {
          console.log(paramData);
          handleInsertPetSuccess();
        },
        error: function (error) {
          console.log(error);
        },
      });
    }
  }

  // hàm xử lý sự kiện update Pet modal click
  function onBtnUpdatePetClick() {
    // khai báo đối tượng chứa Pet data
    var vPetObj = {
      type: "",
      name: "",
      description: "",
      imageUrl: "",
      price: 0,
      promotionPrice: 0,
      discount: 0,
    };
    // B1: Thu thập dữ liệu
    getUpdatePetData(vPetObj);
    // B2: Validate update
    var vIsPetValidate = validatePetUpdateData(vPetObj);
    if (vIsPetValidate) {
      // B3: update Pet
      $.ajax({
        type: "put",
        headers: {
          "Content-Type": "application/json",
        },
        url: gBASE_URL + "/pets/" + gPetId,
        dataType: "json",
        data: JSON.stringify(vPetObj),
        success: function (paramData) {
          console.log(paramData);
          // B4: xử lý front-end
          handleUpdatePetSuccess();
        },
        error: function (error) {
          console.log(error);
        },
      });
    }
  }

  //hàm thực thi khi nút Delete được ấn
  function onBtnDeletePetClick(paramBtnEdit) {
    $("#delete-confirm-modal").modal("show");
    gPetId = getPetIdFromButton(paramBtnEdit);
    $(document).on("click", "#btn-confirm-delete-pet", function () {
      $.ajax({
        type: "delete",
        url: gBASE_URL + "/pets/" + gPetId,
        dataType: "json",
        success: function (paramData) {
          console.log(paramData);
          alert("Xóa thành công");
          getAllPets();
          $("#delete-confirm-modal").modal("hide");
        },
        error: function (error) {
          console.log(error);
        },
      });
    });
  }

  //hàm thực thi khi nút Lọc được ấn
  function onBtnLocClick() {
    var vMinPrice = $("#input-min-price").val();
    var vMaxPrice = $("#input-max-price").val();

    const vQueryParams = new URLSearchParams();

    vQueryParams.append("_limit", 1000);
    vQueryParams.append("_page", 0);
    vQueryParams.append("priceMin", vMinPrice);
    vQueryParams.append("priceMax", vMaxPrice);

    $.ajax({
      type: "get",
      url: gBASE_URL + "/pets?" + vQueryParams.toString(),
      dataType: "json",
      success: function (paramData) {
        console.log(paramData);
        alert("Tìm thấy " + paramData.count + " kết quả");
        loadDataToPetTable(paramData.rows);
      },
      error: function () {
        console.log(error);
      },
    });
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm gọi api để lấy all danh sách Pet đăng ký
  function getAllPets() {
    $.ajax({
      type: "get",
      url: gBASE_URL + "/pets",
      dataType: "json",
      success: function (paramData) {
        console.log(paramData);
        loadDataToPetTable(paramData.rows);
      },
      error: function (error) {
        console.log(error);
      },
    });
  }
  /** load Pet array to DataTable
   * in: Pet array
   * out: Pet table has data
   */
  function loadDataToPetTable(paramPetArr) {
    gSTT = 1;
    gPetTable.clear();
    gPetTable.rows.add(paramPetArr);
    gPetTable.draw();
  }

  // hàm get Pet by id
  function getPetById(paramPetId) {
    $.ajax({
      type: "get",
      url: gBASE_URL + "/pets/" + paramPetId,
      dataType: "json",
      success: function (paramData) {
        console.log(paramData);
        showPetDataToModal(paramData);
      },
      error: function (error) {
        console.log(error);
      },
    });
    // hiển thị modal lên
    $("#update-pet-modal").modal("show");
  }

  // hàm show Pet obj lên modal
  function showPetDataToModal(paramPet) {
    $("#select-update-type").val(paramPet.type);
    $("#input-update-name").val(paramPet.name);
    $("#input-update-description").val(paramPet.description);
    $("#input-update-image").val(paramPet.imageUrl);
    $("#input-update-price").val(paramPet.price);
    $("#input-update-promotion-price").val(paramPet.promotionPrice);
    $("#input-update-discount").val(paramPet.discount);
  }

  // hàm thu thập dữ liệu để create Pet
  function getCreatePetData(paramPetObj) {
    paramPetObj.type = $("#select-create-type").val();
    paramPetObj.name = $("#input-create-name").val().trim();
    paramPetObj.description = $("#input-create-description").val().trim();
    paramPetObj.imageUrl = $("#input-create-image").val().trim();
    paramPetObj.price = $("#input-create-price").val().trim();
    paramPetObj.promotionPrice = $("#input-create-promotion-price")
      .val()
      .trim();
    paramPetObj.discount = $("#input-create-discount").val().trim();
  }

  // hàm thu thập dữ liệu để update Pet
  function getUpdatePetData(paramPetObj) {
    paramPetObj.type = $("#select-update-type").val();
    paramPetObj.name = $("#input-update-name").val().trim();
    paramPetObj.description = $("#input-update-description").val().trim();
    paramPetObj.imageUrl = $("#input-update-image").val().trim();
    paramPetObj.price = $("#input-update-price").val().trim();
    paramPetObj.promotionPrice = $("#input-update-promotion-price")
      .val()
      .trim();
    paramPetObj.discount = $("#input-update-discount").val().trim();
  }

  // hàm validate data
  function validatePetData(paramPetObj) {
    if (paramPetObj.name === "") {
      alert("Pet name cần nhập");
      return false;
    }

    if (paramPetObj.price === "") {
      alert("Pet price cần nhập");
      return false;
    }
    if (isNaN(paramPetObj.price)) {
      alert("Price phải là số");
      return false;
    }
    var vPriceNumber = Number(paramPetObj.price);
    if (vPriceNumber <= 0) {
      alert("Price cần > 0");
      return false;
    }

    if (paramPetObj.promotionPrice === "") {
      alert("Promotion price cần nhập");
      return false;
    }
    if (isNaN(paramPetObj.promotionPrice)) {
      alert("Promotion price phải là số");
      return false;
    }
    var vProPriceNumber = Number(paramPetObj.promotionPrice);
    if (vProPriceNumber <= 0) {
      alert("Promotion price cần > 0");
      return false;
    }
    if (vProPriceNumber >= vPriceNumber) {
      alert("Promotion price phải < price");
      return false;
    }

    if (paramPetObj.discount === "") {
      alert("Discount cần nhập");
      return false;
    }
    if (isNaN(paramPetObj.discount)) {
      alert("Discount phải là số");
      return false;
    }
    var vDiscountNumber = Number(paramPetObj.discount);
    if (vDiscountNumber < 0) {
      alert("Discount cần >= 0");
      return false;
    }
    if (vDiscountNumber >= vPriceNumber) {
      alert("Discount phải < price");
      return false;
    }

    return true;
  }

  // hàm validate data pet update
  function validatePetUpdateData(paramPetObj) {
    if (paramPetObj.name === "") {
      alert("Pet name cần nhập");
      return false;
    }

    if (paramPetObj.price === "") {
      alert("Pet price cần nhập");
      return false;
    }
    if (isNaN(paramPetObj.price)) {
      alert("Price phải là số");
      return false;
    }
    var vPriceNumber = Number(paramPetObj.price);
    if (vPriceNumber <= 0) {
      alert("Price cần > 0");
      return false;
    }

    if (paramPetObj.promotionPrice === "") {
      alert("Promotion price cần nhập");
      return false;
    }
    if (isNaN(paramPetObj.promotionPrice)) {
      alert("Promotion price phải là số");
      return false;
    }
    var vProPriceNumber = Number(paramPetObj.promotionPrice);
    if (vProPriceNumber <= 0) {
      alert("Promotion price cần > 0");
      return false;
    }
    if (vProPriceNumber >= vPriceNumber) {
      alert("Promotion price phải < price");
      return false;
    }

    // Trường discount có thể có hoặc không
    if (paramPetObj.discount !== "") {
      if (isNaN(paramPetObj.discount)) {
        alert("Discount phải là số");
        return false;
      }
      var vDiscountNumber = Number(paramPetObj.discount);
      if (vDiscountNumber < 0) {
        alert("Discount cần >= 0");
        return false;
      }
      if (vDiscountNumber >= vPriceNumber) {
        alert("Discount phải < price");
        return false;
      }
    }

    return true;
  }

  // hàm xử lý hiển thị front-end khi thêm Pet thành công
  function handleInsertPetSuccess() {
    alert("Thêm pet thành công!");
    getAllPets();
    resertCreatePetForm();
    $("#create-pet-modal").modal("hide");
  }

  // hàm xử lý hiển thị front-end khi sửa Pet thành công
  function handleUpdatePetSuccess() {
    alert("Sửa pet thành công!");
    getAllPets();
    resertUpdatePetForm();
    $("#update-pet-modal").modal("hide");
  }

  // hàm xóa trắng form create Pet
  function resertCreatePetForm() {
    $("#select-create-type").val("Dog");
    $("#input-create-name").val("");
    $("#input-create-description").val("");
    $("#input-create-image").val("");
    $("#input-create-price").val("");
    $("#input-create-promotion-price").val("");
    $("#input-create-discount").val("");
  }

  // hàm xóa trắng form update Pet
  function resertUpdatePetForm() {
    $("#select-update-type").val("Dog");
    $("#input-update-name").val("");
    $("#input-update-description").val("");
    $("#input-update-image").val("");
    $("#input-update-price").val("");
    $("#input-update-promotion-price").val("");
    $("#input-update-discount").val("");
  }

  // hàm dựa vào button detail (edit or delete) xác định đc id Pet
  function getPetIdFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vPetRowData = gPetTable.row(vTableRow).data();
    return vPetRowData.id;
  }
</script>
